<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html><head><meta http-equiv="Content-Type" content="text/html;charset=iso-8859-1">
<title>WarpTree: src/warpcoord.h Source File</title>
<link href="doxygen.css" rel="stylesheet" type="text/css">
<link href="tabs.css" rel="stylesheet" type="text/css">
</head><body>
<!-- Generated by Doxygen 1.5.0 -->
<div class="tabs">
  <ul>
    <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
    <li><a href="annotated.html"><span>Classes</span></a></li>
    <li id="current"><a href="files.html"><span>Files</span></a></li>
  </ul></div>
<h1>src/warpcoord.h</h1><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/* This file is part of WarpTree</span>
<a name="l00002"></a>00002 <span class="comment"> *</span>
<a name="l00003"></a>00003 <span class="comment"> * Copyright (C) 2007 Jos van den Oever &lt;jos@vandenoever.info&gt;</span>
<a name="l00004"></a>00004 <span class="comment"> *</span>
<a name="l00005"></a>00005 <span class="comment"> * This library is free software; you can redistribute it and/or</span>
<a name="l00006"></a>00006 <span class="comment"> * modify it under the terms of the GNU Library General Public</span>
<a name="l00007"></a>00007 <span class="comment"> * License as published by the Free Software Foundation; either</span>
<a name="l00008"></a>00008 <span class="comment"> * version 2 of the License, or (at your option) any later version.</span>
<a name="l00009"></a>00009 <span class="comment"> *</span>
<a name="l00010"></a>00010 <span class="comment"> * This library is distributed in the hope that it will be useful,</span>
<a name="l00011"></a>00011 <span class="comment"> * but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00012"></a>00012 <span class="comment"> * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00013"></a>00013 <span class="comment"> * Library General Public License for more details.</span>
<a name="l00014"></a>00014 <span class="comment"> *</span>
<a name="l00015"></a>00015 <span class="comment"> * You should have received a copy of the GNU Library General Public License</span>
<a name="l00016"></a>00016 <span class="comment"> * along with this library; see the file COPYING.LIB.  If not, write to</span>
<a name="l00017"></a>00017 <span class="comment"> * the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,</span>
<a name="l00018"></a>00018 <span class="comment"> * Boston, MA 02110-1301, USA.</span>
<a name="l00019"></a>00019 <span class="comment"> */</span>
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 <span class="comment">// code for transformations was adapted from HyperTree published under</span>
<a name="l00022"></a>00022 <span class="comment">// MIT License 2001 www.bouthier.net</span>
<a name="l00023"></a>00023 
<a name="l00024"></a>00024 <span class="preprocessor">#ifndef WARPTREE_H</span>
<a name="l00025"></a>00025 <span class="preprocessor"></span><span class="preprocessor">#define WARPTREE_H</span>
<a name="l00026"></a>00026 <span class="preprocessor"></span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &lt;iostream&gt;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &lt;cmath&gt;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &lt;cassert&gt;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &lt;cstdlib&gt;</span>
<a name="l00031"></a>00031 
<a name="l00032"></a>00032 <span class="comment">/* This class provides the methods to handle the points in the graph.</span>
<a name="l00033"></a>00033 <span class="comment"> * It allows points to be translated in the unit square.</span>
<a name="l00034"></a>00034 <span class="comment"> */</span>
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 <span class="preprocessor">#define ZONE_LENGTH 4 // size of the zone</span>
<a name="l00037"></a>00037 <span class="preprocessor"></span>
<a name="l00038"></a>00038 <span class="comment">// if WARPCOORD is not defined, the standard Poincare disk projection is used</span>
<a name="l00039"></a>00039 <span class="preprocessor">#define WARPCOORD</span>
<a name="l00040"></a>00040 <span class="preprocessor"></span>
<a name="l00041"></a>00041 <span class="keyword">class </span>WarpCoord;
<a name="l00042"></a>00042 std::ostream&amp; operator&lt;&lt;(std::ostream&amp; o, <span class="keyword">const</span> WarpCoord&amp; e);
<a name="l00043"></a>00043 <span class="keyword">class </span>WarpCoord {
<a name="l00044"></a>00044 <span class="keyword">private</span>:
<a name="l00045"></a>00045     <span class="keywordtype">float</span> mx;
<a name="l00046"></a>00046     <span class="keywordtype">float</span> my;
<a name="l00047"></a>00047     <span class="keywordtype">float</span> md;
<a name="l00048"></a>00048 
<a name="l00049"></a>00049     <span class="comment">/* the value for d is cached in this class. This function updates the</span>
<a name="l00050"></a>00050 <span class="comment">       value */</span>
<a name="l00051"></a>00051     <span class="keyword">inline</span> <span class="keywordtype">void</span> updateD() {
<a name="l00052"></a>00052         md = sqrt(d2());
<a name="l00053"></a>00053     }
<a name="l00054"></a>00054     <span class="comment">/* multiply this point with point z */</span>
<a name="l00055"></a>00055     <span class="keywordtype">void</span>
<a name="l00056"></a>00056     operator*=(<span class="keyword">const</span> WarpCoord&amp; z) {
<a name="l00057"></a>00057         <span class="keywordtype">float</span> tx = mx;
<a name="l00058"></a>00058         mx = tx*z.mx - my * z.my;
<a name="l00059"></a>00059         my = tx*z.my + my * z.mx;
<a name="l00060"></a>00060         updateD();
<a name="l00061"></a>00061     }
<a name="l00062"></a>00062     <span class="comment">/* divide this point by point z */</span>
<a name="l00063"></a>00063     <span class="keywordtype">void</span>
<a name="l00064"></a>00064     operator/=(<span class="keyword">const</span> WarpCoord&amp; z) {
<a name="l00065"></a>00065         <span class="keywordtype">float</span> d2 = z.d2();
<a name="l00066"></a>00066         <span class="keywordtype">float</span> tx = mx;
<a name="l00067"></a>00067         mx = (tx*z.mx + my*z.my) / d2;
<a name="l00068"></a>00068         my = (my*z.mx - tx*z.my) / d2;
<a name="l00069"></a>00069         updateD();
<a name="l00070"></a>00070     }
<a name="l00071"></a>00071 <span class="keyword">public</span>:
<a name="l00072"></a>00072     WarpCoord() :mx(0), my(0), md(0) {}
<a name="l00073"></a>00073     WarpCoord(<span class="keywordtype">float</span> x, <span class="keywordtype">float</span> y) :mx(x), my(y) {
<a name="l00074"></a>00074         updateD();
<a name="l00075"></a>00075     }
<a name="l00076"></a>00076     <span class="keyword">inline</span> <span class="keywordtype">float</span> x()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mx; }
<a name="l00077"></a>00077     <span class="keyword">inline</span> <span class="keywordtype">float</span> y()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> my; }
<a name="l00078"></a>00078     <span class="keyword">inline</span> <span class="keywordtype">float</span> d()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> md; }
<a name="l00079"></a>00079     <span class="keyword">inline</span> <span class="keywordtype">float</span> d2()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mx*mx + my*my; }
<a name="l00080"></a>00080     <span class="comment">/* calculate the arg of this point */</span>
<a name="l00081"></a>00081     <span class="keywordtype">float</span> arg()<span class="keyword"> const </span>{
<a name="l00082"></a>00082         <span class="keywordtype">float</span> a = atan(my / mx);
<a name="l00083"></a>00083         <span class="keywordflow">if</span> (mx &lt; 0) {
<a name="l00084"></a>00084             a += M_PI;
<a name="l00085"></a>00085         } <span class="keywordflow">else</span> <span class="keywordflow">if</span> (my &lt; 0) {
<a name="l00086"></a>00086             a += 2 * M_PI;
<a name="l00087"></a>00087         }
<a name="l00088"></a>00088         <span class="keywordflow">return</span> a;
<a name="l00089"></a>00089     }
<a name="l00090"></a>00090     <span class="comment">/* translate this point by adding the vector t */</span>
<a name="l00091"></a>00091     <span class="keywordtype">void</span> translate(<span class="keyword">const</span> WarpCoord&amp; t) {
<a name="l00092"></a>00092         <span class="keywordtype">float</span> denX = mx * t.mx + my * t.my + 1;
<a name="l00093"></a>00093         <span class="keywordtype">float</span> denY = my * t.mx - mx * t.my;
<a name="l00094"></a>00094         <span class="keywordtype">float</span> dd = denX * denX + denY * denY;
<a name="l00095"></a>00095 
<a name="l00096"></a>00096         <span class="keywordtype">double</span> numX = mx + t.mx;
<a name="l00097"></a>00097         <span class="keywordtype">double</span> numY = my + t.my;
<a name="l00098"></a>00098 
<a name="l00099"></a>00099         mx = (numX * denX + numY * denY) / dd;
<a name="l00100"></a>00100         my = (numY * denX - numX * denY) / dd;
<a name="l00101"></a>00101         updateD();
<a name="l00102"></a>00102     }
<a name="l00103"></a>00103     <span class="comment">/* zoom this point. this means the point move closer to or away from the</span>
<a name="l00104"></a>00104 <span class="comment">       center of the square */</span>
<a name="l00105"></a>00105     <span class="keywordtype">void</span> zoom(<span class="keywordtype">float</span> f) {
<a name="l00106"></a>00106         assert(f &gt; 0);
<a name="l00107"></a>00107         <span class="keywordflow">if</span> (md &lt; 0.001) <span class="keywordflow">return</span>;
<a name="l00108"></a>00108         <span class="keywordtype">float</span> r = md;
<a name="l00109"></a>00109         <span class="keywordtype">float</span> c = pow((1+md)/(1-md),f);
<a name="l00110"></a>00110         c = (c-1)/(c+1)/r;
<a name="l00111"></a>00111         mx *= c;
<a name="l00112"></a>00112         my *= c;
<a name="l00113"></a>00113         md *= c;
<a name="l00114"></a>00114     }
<a name="l00115"></a>00115     <span class="comment">/* move this point from the disk positiong to the square position */</span>
<a name="l00116"></a>00116     <span class="keywordtype">void</span> stretch() {
<a name="l00117"></a>00117         <span class="keywordflow">if</span> (md &lt; 0.0001) <span class="keywordflow">return</span>;
<a name="l00118"></a>00118 <span class="preprocessor">#ifdef WARPCOORD</span>
<a name="l00119"></a>00119 <span class="preprocessor"></span>        <span class="keywordtype">float</span> fx = fabs(mx);
<a name="l00120"></a>00120         <span class="keywordtype">float</span> fy = fabs(my);
<a name="l00121"></a>00121         <span class="keywordflow">if</span> (fy &gt; 0 &amp;&amp; fy &gt; fx) {
<a name="l00122"></a>00122             <span class="keywordtype">float</span> f = md/fy;
<a name="l00123"></a>00123             my = (my&gt;0) ?md :-md;
<a name="l00124"></a>00124             mx *= f;
<a name="l00125"></a>00125             md *= f;
<a name="l00126"></a>00126         } <span class="keywordflow">else</span> <span class="keywordflow">if</span> (fx &gt; 0) {
<a name="l00127"></a>00127             <span class="keywordtype">float</span> f = md/fx;
<a name="l00128"></a>00128             mx = (mx&gt;0) ?md :-md;
<a name="l00129"></a>00129             my *= f;
<a name="l00130"></a>00130             md *= f;
<a name="l00131"></a>00131         }
<a name="l00132"></a>00132 <span class="preprocessor">#endif</span>
<a name="l00133"></a>00133 <span class="preprocessor"></span>    }
<a name="l00134"></a>00134     <span class="comment">/* move this point from the square position to the disk position */</span>
<a name="l00135"></a>00135     <span class="keywordtype">void</span> unstretch() {
<a name="l00136"></a>00136         assert(md &gt;= 0);
<a name="l00137"></a>00137         <span class="keywordflow">if</span> (md &lt; 0.0001) <span class="keywordflow">return</span>;
<a name="l00138"></a>00138 <span class="preprocessor">#ifdef WARPCOORD</span>
<a name="l00139"></a>00139 <span class="preprocessor"></span>        <span class="keywordtype">float</span> f = 1;
<a name="l00140"></a>00140         <span class="keywordtype">float</span> fx = fabs(mx);
<a name="l00141"></a>00141         <span class="keywordtype">float</span> fy = fabs(my);
<a name="l00142"></a>00142         <span class="keywordflow">if</span> (fy &gt; 0 &amp;&amp; fy &gt; fx) {
<a name="l00143"></a>00143             f = md/fy;
<a name="l00144"></a>00144             md = (my&gt;0) ?my :-my;
<a name="l00145"></a>00145         } <span class="keywordflow">else</span> <span class="keywordflow">if</span> (fx &gt; 0) {
<a name="l00146"></a>00146             f = md/fx;
<a name="l00147"></a>00147             md = (mx&gt;0) ?mx :-mx;
<a name="l00148"></a>00148         }
<a name="l00149"></a>00149         mx /= f;
<a name="l00150"></a>00150         my /= f;
<a name="l00151"></a>00151 <span class="preprocessor">#endif</span>
<a name="l00152"></a>00152 <span class="preprocessor"></span>    }
<a name="l00153"></a>00153     <span class="comment">/* is this point visible, in other words, is it not too close to the edge</span>
<a name="l00154"></a>00154 <span class="comment">       of the unit square */</span>
<a name="l00155"></a>00155     <span class="keyword">inline</span> <span class="keywordtype">bool</span> visible()<span class="keyword"> const </span>{
<a name="l00156"></a>00156         <span class="keywordflow">return</span> mx &gt; -0.95 &amp;&amp; mx &lt; 0.95 &amp;&amp; my &gt; -0.95 &amp;&amp; my &lt; 0.95;
<a name="l00157"></a>00157     }
<a name="l00158"></a>00158     <span class="comment">/* is this point valid, in other words, does it lie inside the unit</span>
<a name="l00159"></a>00159 <span class="comment">       square */</span>
<a name="l00160"></a>00160     <span class="keyword">inline</span> <span class="keywordtype">bool</span> valid()<span class="keyword"> const </span>{
<a name="l00161"></a>00161         <span class="keywordflow">return</span> mx &gt; -1 &amp;&amp; mx &lt; 1 &amp;&amp; my &gt; -1 &amp;&amp; my &lt; 1;
<a name="l00162"></a>00162     }
<a name="l00163"></a>00163     <span class="comment">/* return the negative value of this point */</span>
<a name="l00164"></a>00164     <span class="keyword">inline</span> WarpCoord operator-()<span class="keyword"> const </span>{
<a name="l00165"></a>00165         <span class="keywordflow">return</span> WarpCoord(-mx, -my);
<a name="l00166"></a>00166     }
<a name="l00167"></a>00167     <span class="comment">/* substract the value of point e from this point. Note that this is not</span>
<a name="l00168"></a>00168 <span class="comment">       equal to translation. */</span>
<a name="l00169"></a>00169     <span class="keyword">inline</span> <span class="keywordtype">void</span> operator-=(<span class="keyword">const</span> WarpCoord&amp; e) {
<a name="l00170"></a>00170         mx -= e.mx;
<a name="l00171"></a>00171         my -= e.my;
<a name="l00172"></a>00172         updateD();
<a name="l00173"></a>00173     }
<a name="l00174"></a>00174     <span class="comment">/* apply the translation that is needed to get from point c1 to c2 to this</span>
<a name="l00175"></a>00175 <span class="comment">       point */</span>
<a name="l00176"></a>00176     <span class="keywordtype">void</span> transform(<span class="keyword">const</span> WarpCoord&amp; c1, <span class="keyword">const</span> WarpCoord&amp; c2) {
<a name="l00177"></a>00177         WarpCoord p(c1.mx + c2.mx, c1.my + c2.my);
<a name="l00178"></a>00178 
<a name="l00179"></a>00179         WarpCoord d(c2.mx, -c2.my);
<a name="l00180"></a>00180         d *= c1;
<a name="l00181"></a>00181         d.mx += 1;
<a name="l00182"></a>00182         p /= d;
<a name="l00183"></a>00183 
<a name="l00184"></a>00184         WarpCoord o(c1.mx, -c1.my);
<a name="l00185"></a>00185         o *= c2;
<a name="l00186"></a>00186         o.mx += 1;
<a name="l00187"></a>00187         o /= d;
<a name="l00188"></a>00188 
<a name="l00189"></a>00189         WarpCoord z(*<span class="keyword">this</span>);
<a name="l00190"></a>00190         *<span class="keyword">this</span> *= o;
<a name="l00191"></a>00191         mx += p.mx;
<a name="l00192"></a>00192         my += p.my;
<a name="l00193"></a>00193 
<a name="l00194"></a>00194         d.set(p.mx, -p.my);
<a name="l00195"></a>00195         d *= z;
<a name="l00196"></a>00196         d *= o;
<a name="l00197"></a>00197         d.mx += 1;
<a name="l00198"></a>00198 
<a name="l00199"></a>00199         *<span class="keyword">this</span> /= d;
<a name="l00200"></a>00200         updateD();
<a name="l00201"></a>00201     }
<a name="l00202"></a>00202     <span class="comment">/* change the value of this point */</span>
<a name="l00203"></a>00203     <span class="keyword">inline</span> <span class="keywordtype">void</span> set(<span class="keywordtype">float</span> x, <span class="keywordtype">float</span> y) {
<a name="l00204"></a>00204         mx = x;
<a name="l00205"></a>00205         my = y;
<a name="l00206"></a>00206         updateD();
<a name="l00207"></a>00207     }
<a name="l00208"></a>00208 };
<a name="l00209"></a>00209 
<a name="l00210"></a>00210 <span class="preprocessor">#endif </span>
</pre></div><hr size="1"><address style="align: right;"><small>Generated on Sat Jun 2 19:18:06 2007 for WarpTree by&nbsp;
<a href="http://www.doxygen.org/index.html">
<img src="doxygen.png" alt="doxygen" align="middle" border="0"></a> 1.5.0 </small></address>
</body>
</html>
